/*
 * i2c.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */


#ifndef __I2C_H__
#define __I2C_H__


/*****************/
/*@ User setting */
/*****************/

/* Control */
#define	IIC_IICC0_LREL0			0x0040
#define	IIC_IICC0_WREL0			0x0020
#define	IIC_IICC0_WTIM0			0x0008
#define	IIC_IICC0_ACKE0			0x0004
#define	IIC_IICC0_STT0			0x0002
#define	IIC_IICC0_SPT0			0x0001

/* Clock */
#define IIC_IICCL0_SMC_NRML		0x0000
#define IIC_IICCL0_SMC_FAST		0x0008

/* Flag */
#define IIC_IICF0_STCEN_DIS		0x0000
#define IIC_IICF0_STCEN_EN		0x0002
#define IIC_IICF0_IICRSV_DIS	0x0000
#define IIC_IICF0_IICRSV_EN		0x0001


/********************/
/*@ Type definition */
/********************/

/* structure */
typedef struct {
	unsigned short ctrl;
	unsigned char  slave_adr;
	unsigned short clock;
	unsigned short flag;
} i2c_config_t;


/***********/
/*@ Extern */
/***********/
extern int i2c_init(i2c_config_t *config);
extern int i2c_exit(void);
extern int i2c_write(i2c_config_t *config, unsigned char reg, unsigned char data);
extern int i2c_read(i2c_config_t *config, unsigned char reg, unsigned char *data, int num);


#endif    /* __I2C_H__ */

