/*
 * icx.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_H__
#define __ICX_H__

#include <common.h>

#include "icx_io.h"
#include "../reg.h"


/****************/
/*@ Boot Option */
/****************/

/* normal / emergency */
#define ICX_BOOT_NORMAL				0x00
#define ICX_BOOT_FWUP				0x01
#define ICX_BOOT_EMERGENCY			(ICX_BOOT_FWUP)

/* boot mode in CHG */
#define	ICX_BOOT_MODE_MASK			0x0000000E
#define	ICX_BOOT_MODE_SD			0x00000004
#define	ICX_BOOT_MODE_MS			0x00000006
#define ICX_BOOT_MODE_CHK(m)		((inl(CHG_BOOT_MODE) & ICX_BOOT_MODE_MASK) == m)

/* board kind(BB/Set) */
#define ICX_BOOT_SRAM_MISC_ADR		0xA0000108
#define ICX_BOOT_SRAM_MISC_MAGIC	0x664D0000
#define ICX_BOOT_SRAM_MISC_BB		0x00000000
#define ICX_BOOT_SRAM_MISC_SET		0x00000001

/* password length */
#define ICX_BOOT_PWD_LEN			32


/**************/
/*@ Prototype */
/**************/
extern int  icx_init(void);	
extern void emmc_boot_linux(unsigned int boot_mode);
extern int  check_pwd(const char *pwd, int len);

#endif /* __ICX_H__ */

