/*
 * icx_beep.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_BEEP_H__
#define __ICX_BEEP_H__


/****************/
/*@ Definitions */
/****************/

/* beep on/off */
#define	ICX_BEEP_OFF				0
#define	ICX_BEEP_ON					1

/* beep period */
#define ICX_BEEP_TIME_CONTINUOUS	0			/* continuous	*/
#define ICX_BEEP_TIME_100MS			100000		/* 100ms    	*/


/********************/
/*@ Type definition */
/********************/

/* Beep operation */
typedef struct {
	void (*power_on)(void);
	void (*power_off)(void);
	void (*beep_enable)(void);
	void (*beep_disable)(void);
	void (*beep_on)(unsigned int);
	void (*beep_off)(void);
} icx_beep_ops_t;


/***************/
/*@ Prototypes */
/***************/
extern int  icx_beep_init(void);
extern void icx_beep_exit(void);
extern void icx_beep_enable(void);
extern void icx_beep_disable(void);
extern void icx_beep_on(unsigned int period);
extern void icx_beep_off(void);


#endif	/* __ICX_BEEP_H__ */ 
