/*
 * icx_key.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_KEY_H__
#define __ICX_KEY_H__

/****************/
/*@ Definitions */
/****************/

/* key code */
#define	ICX_KEY_NOT_PRESSED			0xFFFF

#define	ICX_KEY_CODE_PLAY			0x0100		/* KEY_AD0-0 : S1002	*/
#define	ICX_KEY_CODE_RIGHT			0x0200		/* KEY_AD0-1 : S1004	*/
#define	ICX_KEY_CODE_LEFT			0x0400		/* KEY_AD0-2 : S1007	*/
#define	ICX_KEY_CODE_UP				0x0800		/* KEY_AD0-3 : S1010	*/
#define	ICX_KEY_CODE_DOWN			0x1000		/* KEY_AD0-4 : S1012	*/
#define	ICX_KEY_CODE_ZAPPIN			0x2000		/* KEY_AD0-5 : S1015	*/
#define	ICX_KEY_CODE_AD0_6			0x4000		/* KEY_AD0-6 : S1018	*/
#define	ICX_KEY_CODE_AD0_7			0x8000		/* KEY_AD0-7 : S1020	*/
#define	ICX_KEY_CODE_VOLDOWN		0x0001		/* KEY_AD1-0 : S1003	*/
#define	ICX_KEY_CODE_VOLUP			0x0002		/* KEY_AD1-1 : S1005	*/
#define	ICX_KEY_CODE_BACK			0x0004		/* KEY_AD1-2 : S1008	*/
#define	ICX_KEY_CODE_OPTION			0x0008		/* KEY_AD1-3 : S1011	*/
#define	ICX_KEY_CODE_BT				0x0010		/* KEY_AD1-4 : S1013	*/
#define	ICX_KEY_CODE_AD1_5			0x0020		/* KEY_AD1-5 : S1016	*/
#define	ICX_KEY_CODE_AD1_6			0x0040		/* KEY_AD1-6 : S1019	*/
#define	ICX_KEY_CODE_AD1_7			0x0080		/* KEY_AD1-7 : S1021	*/

/* hold */
#define	ICX_KEY_HOLD_OFF			0
#define	ICX_KEY_HOLD_ON				1

/* hold status */
#define	ICX_KEY_HOLD_CHK_TIMEOUT	0
#define	ICX_KEY_HOLD_CHK_CANCEL		1
#define	ICX_KEY_HOLD_CHK_CANCEL_PSW	2
#define	ICX_KEY_HOLD_CHK_CANCEL_RTC	3


/***************/
/*@ Prototypes */
/***************/

extern void			  icx_key_init(void);
extern unsigned short icx_key_get_key_value(void);
extern void			  icx_key_save_key_value(unsigned short key_value);
extern int			  icx_key_check_key_code(unsigned short key_value, unsigned short key_code);
extern unsigned int   icx_key_get_hold(unsigned char *hold_state);
extern unsigned char  icx_key_check_cancel_hold(void);

#endif	/* __ICX_KEY_H__ */ 
