/*
 * icx_lcdc.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_LCDC_H__
#define	__ICX_LCDC_H__

#include "lcdc.h"


/***********/
/*@ Macros */
/***********/

#define	ICX_LCDC_OFF					0
#define	ICX_LCDC_ON						1

#define	ICX_LCDC_BRIGHTNESS_MIN			0
#define	ICX_LCDC_BRIGHTNESS_MAX			100

#define	ICX_LCDC_FADE_INTERVAL_OPENING	5000
#define	ICX_LCDC_FADE_INTERVAL_HOLD		1000
#define	ICX_LCDC_FADE_INTERVAL_LOWBATT	1000
#define	ICX_LCDC_FADE_INTERVAL_OFF		100


/********************/
/*@ type definition */
/********************/

/* LCDC operation */
typedef struct {
	int  (*power_on)(void);	
	void (*power_off)(void);	
	void (*backlight_init)(lcdc_config_t *config);
	void (*backlight_exit)(void);
	int  (*backlight_control)(lcdc_config_t *config, int deg);
} icx_lcdc_ops_t;


/**************/
/*@ prototype */
/**************/
extern int  icx_lcdc_init(void);
extern int  icx_lcdc_power_on(void);
extern void icx_lcdc_power_off(void);
extern int  icx_lcdc_switch(int onoff);
extern int  icx_lcdc_draw_image(int id);
extern int  icx_lcdc_backlight_control(int deg, int interval);


#endif /* __ICX_LCDC_H__ */
