/*
 * icx_nvp.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ICX_NVP_H__
#define __ICX_NVP_H__

#include "icx_pm.h"

/***************/
/*@ Area table */
/***************/

/* area ID */
enum {
	ICX_NVP_ID_UBOOT_PARAM = 0,
	ICX_NVP_ID_BOOT_IMAGE,
	ICX_NVP_ID_HOLD_IMAGE,
	ICX_NVP_ID_LOWBATT_IMAGE,
	ICX_NVP_ID_SYS_PARAM,
	ICX_NVP_ID_NUM
};

#define ICX_NVP_SYS_SHP 3


/***********************/
/*@ System information */
/***********************/

#define	ICX_NVP_SYSINFO_INVALID		0xFFFFFFFF

/* MEM size */
#define	ICX_NVP_SYSINFO_MEM_MSK		0x00000018
#define	ICX_NVP_SYSINFO_MEM_SFT		3
#define	ICX_NVP_SYSINFO_MEM_064M	0x00000000
#define	ICX_NVP_SYSINFO_MEM_128M	0x00000008

/* LCD device */
#define	ICX_NVP_SYSINFO_LCD_MSK		0x00001800
#define	ICX_NVP_SYSINFO_LCD_SFT		11
#define	ICX_NVP_SYSINFO_LCD_BEATLE	0x00000000
#define	ICX_NVP_SYSINFO_LCD_SWAN	0x00000800
#define	ICX_NVP_SYSINFO_LCD_FALCON	0x00001000

/* DAC device */
#define	ICX_NVP_SYSINFO_DAC_MSK		0x00180000
#define	ICX_NVP_SYSINFO_DAC_SFT		19
#define	ICX_NVP_SYSINFO_DAC_L56		0x00000000
#define	ICX_NVP_SYSINFO_DAC_KMKR	0x00080000

/* Hold mode */
#define	ICX_NVP_HOLD_MODE_ALL		0x00000001
#define	ICX_NVP_HOLD_MODE_TP		0x00000000

/* Ship Information */
#define ICX_NVP_SYS_SHP_CEW			0x00000003


/***************/
/*@ Prototypes */
/***************/

extern void			icx_nvp_init(void);
extern unsigned int icx_nvp_get_sysinfo(void);
extern unsigned int icx_nvp_get_sysinfo_mem(void);
extern unsigned int icx_nvp_get_sysinfo_lcd(void);
extern unsigned int icx_nvp_get_sysinfo_dac(void);
extern unsigned int icx_nvp_get_ship_information(void);
extern void 		icx_nvp_get_image_data(int id, char *buf, int size);
extern void			icx_nvp_get_rtc_date(icx_pm_date_t *date_buf);
extern int			icx_nvp_check_fw_update(void);
extern int			icx_nvp_check_beep_flag(void);
extern int			icx_nvp_check_hold_mode(void);
extern void			icx_nvp_get_pwd(char *pwd_buf);

#endif	/* __ICX_NVP_H__ */ 
