/*
 * pwc.h
 *
 * Copyright 2008,2009 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __PWC_H__
#define	__PWC_H__


/************************/
/*@ Address of Register */
/************************/

/* Register 					Address		   R/W		Reset value */
#define PWC_PWR_REGA			0x02		/*  W		0x03		*/	
#define PWC_PWR_PSCNT1			0x04		/*  W					*/
#define PWC_PWR_PSCNT2			0x06		/*  W		0x02(ROM)	*/
#define PWC_PWR_VOUTSET1		0x0A		/*  W		0xAC		*/
#define PWC_PWR_VOUTSET2		0x0C		/*  W		0xA8		*/
#define PWC_GPIO_IOSEL1			0x10		/*  W					*/
#define PWC_GPIO_IOSEL2			0x12		/*  W					*/
#define PWC_GPIO_IOOUT1			0x14		/*	W					*/
#define PWC_GPIO_IOOUT2			0x16		/*  W					*/
#define	PWC_GPIO_IOIN1			0x15		/*	R					*/
#define	PWC_GPIO_IOIN2			0x17		/*	R					*/
#define PWC_GPIO_GPPUPD1		0x18		/*  W		0x00		*/
#define PWC_GPIO_GPPUPD2		0x1A		/*  W		0x00		*/
#define PWC_GPIO_GPPUPD3		0x1C		/*	W		0x55		*/
#define PWC_GPIO_GPPUPD4		0x1E		/*	W		0x55		*/
#define	PWC_INTC_FMASK1			0x20		/*	W					*/
#define	PWC_INTC_FACTOR1		0x21		/*	R					*/
#define	PWC_INTC_FMASK2			0x22		/*	W					*/
#define	PWC_INTC_FACTOR2		0x23		/*	R					*/
#define	PWC_INTC_FMASK3			0x24		/*	W					*/
#define	PWC_INTC_FACTOR3		0x25		/*	R					*/
#define	PWC_INTC_CLRFACT1		0x2C		/*	W					*/
#define	PWC_INTC_CLRFACT2		0x2E		/*	W					*/
#define	PWC_INTC_CLRFACT3		0x30		/*	W					*/
#define	PWC_INTC_DETMOD1L		0x32		/*	W					*/
#define	PWC_INTC_DETMOD1H		0x34		/*	W					*/
#define	PWC_INTC_DETMOD2L		0x36		/*	W					*/
#define	PWC_INTC_DETMOD2H		0x38		/*	W					*/
#define	PWC_INTC_DETMOD3L		0x3A		/*	W					*/
#define	PWC_INTC_DETMOD3H		0x3C		/*	W					*/
#define	PWC_INTC_BMASK1			0x3E		/*	W					*/
#define	PWC_INTC_BMASK2			0x40		/*	W					*/
#define	PWC_INTC_BMASK3			0x42		/*	W					*/
#define PWC_INTC_REGPWONMSK		0x4C		/*	W					*/
#define	PWC_ADC_ADDATA1			0x4D		/*	R					*/
#define	PWC_ADC_ADMODE			0x4E		/*	W					*/
#define	PWC_ADC_ADDATA2			0x4F		/*	R					*/
#define	PWC_ADC_ADDATA3			0x51		/*	R					*/
#define	PWC_ADC_ADDATA4			0x53		/*	R					*/
#define	PWC_ADC_ADDATA5			0x55		/*	R					*/
#define	PWC_ADC_ADDATA6			0x57		/*	R					*/
#define	PWC_ADC_ADDATA7			0x59		/*	R					*/
#define	PWC_ADC_ADDATA8			0x5B		/*	R					*/
#define PWC_CHG_CHGCNTR1		0x5C		/*	W		0x03		*/
#define	PWC_CHG_CHGIRR			0x5D		/*	R					*/
#define	PWC_CHG_CHGSTATE		0x5F		/*	R					*/
#define PWC_CHG_TIMCNTR			0x60		/*	W		0x02		*/
#define	PWC_PSW_STATE			0x65		/*	R					*/
#define	PWC_INTC_WRSTFCT		0x6D		/*	R					*/
#define	PWC_INTC_WRSTCL			0x6E		/*	W					*/
#define	PWC_LSIVER				0x6F		/*	R					*/
#define	PWC_RTC_SEC_RD			0x71		/*	R					*/
#define	PWC_RTC_MIN_RD			0x73		/*	R					*/
#define	PWC_RTC_HOUR_RD			0x75		/*	R					*/
#define	PWC_RTC_WEEK_RD			0x77		/*	R					*/
#define	PWC_RTC_DAY_RD			0x79		/*	R					*/
#define	PWC_RTC_MONTH_RD		0x7B		/*	R					*/
#define	PWC_RTC_YEAR_RD			0x7D		/*	R					*/
#define	PWC_RTC_TRIM_RD			0x7F		/*	R					*/
#define	PWC_RTC_ALM_WM_RD		0x81		/*	R					*/
#define	PWC_RTC_ALM_WH_RD		0x83		/*	R					*/
#define	PWC_RTC_ALM_WW_RD		0x85		/*	R					*/
#define	PWC_RTC_ALM_DM_RD		0x87		/*	R					*/
#define	PWC_RTC_ALM_DH_RD		0x89		/*	R					*/
#define	PWC_RTC_RTC1			0x8A		/*	W					*/
#define	PWC_RTC_RTC1_RD			0x8B		/*	R					*/
#define	PWC_RTC_RTC2			0x8C		/*	R					*/
#define	PWC_RTC_RTC2_RD			0x8D		/*	R					*/
#define PWC_USB_USBCONT			0x90		/*	W		0x07		*/
#define	PWC_INTC_WRSTMSK		0x92		/*  W					*/


/***************/
/*@ Bit assign */
/***************/

/* PWR */
#define	PWC_PSCNT1_REGLOG			0x08
#define	PWC_PSCNT1_REGHP			0x04
#define	PWC_PSCNT1_REGANA			0x02

/* DETMOD */
#define PWC_DETMOD_LEVEL			0x00
#define PWC_DETMOD_RISE				0x01
#define PWC_DETMOD_FALL				0x02
#define PWC_DETMOD_MASK				0x03

#define	PWC_DETMOD3L_ADINT_SFT		0

/* FACTOR */
#define	PWC_FACT_ADINT				0x01

/* ADC */
#define	PWC_ADRQ_STOP				0x00
#define	PWC_ADRQ_SINGLE				0x10
#define	PWC_ADRQ_MASK				0x30

#define	PWC_ADSEL_VCCVBAT			0
#define	PWC_ADSEL_VCCVBUS			1
#define	PWC_ADSEL_ADIN3				2
#define	PWC_ADSEL_ADIN4				3
#define	PWC_ADSEL_ADIN5				4
#define	PWC_ADSEL_ADIN6				5
#define	PWC_ADSEL_ADIN7				6
#define	PWC_ADSEL_ADIN8				7
#define	PWC_ADSEL_MAX				(PWC_ADSEL_ADIN8)
#define	PWC_ADSEL_MASK				0x07

/* GPIO */
#define	PWC_GPIO_IO00				0x01
#define	PWC_GPIO_IO01				0x02
#define	PWC_GPIO_IO02				0x04
#define	PWC_GPIO_IO03				0x08
#define	PWC_GPIO_IO04				0x10
#define	PWC_GPIO_IO05				0x20
#define	PWC_GPIO_IO06				0x40
#define	PWC_GPIO_IO07				0x80
#define	PWC_GPIO_IO08				0x01
#define	PWC_GPIO_IO09				0x02
#define	PWC_GPIO_IO10				0x04
#define	PWC_GPIO_IO11				0x08
#define	PWC_GPIO_IO12				0x10
#define	PWC_GPIO_IO13				0x20
#define	PWC_GPIO_IO14				0x40
#define	PWC_GPIO_IO15				0x80

#define	PWC_GPIO_IOSEL_IN			0x00
#define	PWC_GPIO_IOSEL_OUT			0xFF

#define	PWC_GPIO_GPPUPD_OPEN		0x00
#define	PWC_GPIO_GPPUPD_DOWN		0x01
#define	PWC_GPIO_GPPUPD_UP			0x02
#define	PWC_GPIO_GPPUPD_MSK			0x03

#define	PWC_GPIO_GPPUPD_SFT_IO00	0x00
#define	PWC_GPIO_GPPUPD_SFT_IO01	0x02
#define	PWC_GPIO_GPPUPD_SFT_IO02	0x04
#define	PWC_GPIO_GPPUPD_SFT_IO03	0x06
#define	PWC_GPIO_GPPUPD_SFT_IO04	0x00
#define	PWC_GPIO_GPPUPD_SFT_IO05	0x02
#define	PWC_GPIO_GPPUPD_SFT_IO06	0x04
#define	PWC_GPIO_GPPUPD_SFT_IO07	0x06
#define	PWC_GPIO_GPPUPD_SFT_IO08	0x00
#define	PWC_GPIO_GPPUPD_SFT_IO09	0x02
#define	PWC_GPIO_GPPUPD_SFT_IO10	0x04
#define	PWC_GPIO_GPPUPD_SFT_IO11	0x06
#define	PWC_GPIO_GPPUPD_SFT_IO12	0x00
#define	PWC_GPIO_GPPUPD_SFT_IO13	0x02
#define	PWC_GPIO_GPPUPD_SFT_IO14	0x04
#define	PWC_GPIO_GPPUPD_SFT_IO15	0x06

/* INTC */
#define	PWC_INTC_FACTOR_ALL			0xFF
#define	PWC_INTC_FACTOR1_GPIO0		(PWC_GPIO_IO00)
#define	PWC_INTC_FACTOR1_GPIO1		(PWC_GPIO_IO01)
#define	PWC_INTC_FACTOR1_GPIO2		(PWC_GPIO_IO02)
#define	PWC_INTC_FACTOR1_GPIO3		(PWC_GPIO_IO03)
#define	PWC_INTC_FACTOR1_GPIO4		(PWC_GPIO_IO04)
#define	PWC_INTC_FACTOR1_GPIO5		(PWC_GPIO_IO05)
#define	PWC_INTC_FACTOR1_GPIO6		(PWC_GPIO_IO06)
#define	PWC_INTC_FACTOR1_GPIO7		(PWC_GPIO_IO07)

#define	PWC_INTC_FACTOR3_FRTCINT	0x02

#define	PWC_INTC_WRSTFCT_ALL		0x03

/* PSW_STATE */
#define PWC_PSW_STATE_SDETADP		0x10
#define PWC_PSW_STATE_SDETUSB		0x20

/***************/
/*@ PIN assign */
/***************/

#define PM_GPIO_CHG_STAT1			PWC_GPIO_IO05
#define PM_GPIO_CHG_STAT2			PWC_GPIO_IO06
#define PM_GPIO_CHG_V_LOW			PWC_GPIO_IO09
#define PM_GPIO_VBUS_I_HIGH			PWC_GPIO_IO11
#define PM_GPIO_CHG_XEN				PWC_GPIO_IO12
#define PM_GPIO_CHG_I_HIGH			PWC_GPIO_IO13
#define PM_GPIO_VBUS_SUSPEND		PWC_GPIO_IO14
#define BEEP_GPIO_HP_XMUTE2			PWC_GPIO_IO15

/********************/
/*@ Regulator Types */
/********************/

#define PWC_REGULATOR_MIC 0x00001004
#define PWC_REGULATOR_LOG 0x00010804
#define PWC_REGULATOR_HP  0x00020404
#define PWC_REGULATOR_ANA 0x00030204
#define PWC_REGULATOR_DSP 0x00040104
#define PWC_REGULATOR_GP5 0x00050806
#define PWC_REGULATOR_GP4 0x00060406
#define PWC_REGULATOR_GP3 0x00070206
#define PWC_REGULATOR_GP2 0x00080106
#define PWC_REGULATOR_USB 0x00090290
#define PWC_MAX_REGULATOR 10

/***************/
/*@ Prototypes */
/***************/

extern void pwc_init(void);
extern int  pwc_regulator_on(unsigned int regulator);
extern int  pwc_regulator_off(unsigned int regulator);
extern int  pwc_read(u_int addr, u_char *data);
extern int  pwc_write(u_int addr, u_char data, u_char mask);

#endif /* __PWC_H__ */
